Attribute VB_Name = "Tracage"
Option Explicit
Const MAX = 79 '250 ou 96 ATTENTION --> MODIFIER CALCAL.MAX AUSSI

'== Trace les chronogrammes en mode scope ==
Public Sub trace(canal1() As Byte, canal2() As Byte, canal3() As Byte, canal4() As Byte)
  Dim Cx, Cy, i As Integer

  Moyenne canal1, canal2  ' calcul de la moyenne + min + max
  '--------------------------------------------------------
  ' Emulation Aquisition
  '##############################DEBUG######DEBUG##########
  'If FormPrinc.CH(1).Value = Checked Then
  ' For i = 0 To MAX
  '     canal1(i) = 100 * Sin(i / 5) + 128  '#DEBUG
  '  Next i
  'End If
  
  'If FormPrinc.CH(2).Value = Checked Then
  '  For i = 0 To MAX
  '      canal2(i) = 0.7 * 100 * Sin(i / 5 * 2 + 1.78) + 128 '#DEBUG
  '  Next i
  'End If
  '##############################DEBUG######DEBUG##########
  If FormPrinc.CH(3).Value = Checked Then
    For i = 0 To MAX
        canal3(i) = 0.1 * 100 * Sin(i / 5 + 2) + 128 '#DEBUG
    Next i
  End If
  
  If FormPrinc.CH(4).Value = Checked Then
    For i = 0 To MAX
        canal4(i) = 100 * Sin(i / 5 + 3.14) + 128 '#DEBUG
    Next i
  End If

'--------------------------------------------------------
' Trace les chronogrammes
  FormPrinc.Scope.Cls
  traceGrille
  Cx = FormPrinc.Scope.ScaleWidth   ' Obtient le max horizontal
  Cy = FormPrinc.Scope.ScaleHeight  ' Obtient le max vertical (bas droite)
  'Scope.Line (0, 0)-(Cx, Cy)
    
  If FormPrinc.CH(1).Value = Checked Then
    FormPrinc.Scope.ForeColor = QBColor(1)
    FormPrinc.Scope.PSet (0, (255 - canal1(0) + FormPrinc.Slider2(1).Value - 128) / 255 * Cy)
    For i = 0 To MAX
      FormPrinc.Scope.Line -(Cx / MAX * i, (255 - canal1(i) + FormPrinc.Slider2(1).Value - 128) / 255 * Cy)
      'Scope.Line -(Cx / MAX * i, (255 - canal1(i)) / 255 * Cy)
    Next i
  End If
    
  If FormPrinc.CH(2).Value = Checked Then
    FormPrinc.Scope.ForeColor = QBColor(2)
    FormPrinc.Scope.PSet (0, (255 - canal2(0) + FormPrinc.Slider2(2).Value - 128) / 255 * Cy)
    For i = 0 To MAX
      FormPrinc.Scope.Line -(Cx / MAX * i, (255 - canal2(i) + FormPrinc.Slider2(2).Value - 128) / 255 * Cy)
    Next i
  End If
    
  If FormPrinc.CH(3).Value = Checked Then
    FormPrinc.Scope.ForeColor = QBColor(3)
    FormPrinc.Scope.PSet (0, (255 - canal3(0) + FormPrinc.Slider2(3).Value - 128) / 255 * Cy)
    For i = 0 To MAX
      FormPrinc.Scope.Line -(Cx / MAX * i, (255 - canal3(i) + FormPrinc.Slider2(3).Value - 128) / 255 * Cy)
    Next i
  End If
  
  If FormPrinc.CH(4).Value = Checked Then
    FormPrinc.Scope.ForeColor = QBColor(4)
    FormPrinc.Scope.PSet (0, (255 - canal4(0) + FormPrinc.Slider2(4).Value - 128) / 255 * Cy)
    For i = 0 To MAX
      FormPrinc.Scope.Line -(Cx / MAX * i, (255 - canal4(i) + FormPrinc.Slider2(4).Value - 128) / 255 * Cy)
    Next i
  End If
  
  FormPrinc.AffParam                          ' Affiche les parametres sur le bitmap
End Sub

'== Trace les chronogrammes en mode XY ==
Public Sub traceXY(canal1() As Byte, canal2() As Byte)
'Mode XY
    Dim Cx, Cy, i As Integer
    FormPrinc.Scope.Cls
    traceGrille
    'For i = 0 To MAX
    '  canal1(i) = 128 * Sin(i / 5) + 128 '#DEBUG
    'Next i
    'For i = 0 To MAX
    '  canal2(i) = 128 * Sin(i / 5 + 3.1415 / 4) + 128 '#DEBUG
    'Next i
    Cx = FormPrinc.Scope.ScaleWidth   ' Obtient le max horizontal
    Cy = FormPrinc.Scope.ScaleHeight  ' Obtient le max vertical (bas droite)
    'Scope.Line (0, 0)-(Cx, Cy)
    
    FormPrinc.Scope.PSet (1 / 10 * Cx + 4 / 5 * (canal1(0) - FormPrinc.Slider2(1).Value + 128) / 255 * Cx, _
                (255 - canal2(0) + FormPrinc.Slider2(2).Value - 128) / 255 * Cy)
    For i = 0 To MAX
      FormPrinc.Scope.ForeColor = QBColor(1)  '(i Mod 15)
      FormPrinc.Scope.Line -(1 / 10 * Cx + 4 / 5 * (canal1(i) - FormPrinc.Slider2(1).Value + 128) / 255 * Cx, _
                    (255 - canal2(i) + FormPrinc.Slider2(2).Value - 128) / 255 * Cy)
    Next i
    FormPrinc.AffParam                          ' Affiche les parametres sur le bitmap
End Sub

Public Sub traceGrille()
    Dim X, Y As Byte
    Dim Cx, Cy As Integer
    
    FormPrinc.Scope.DrawMode = 13 'Copy Pen
    FormPrinc.Scope.DrawStyle = 0 'Solid
    FormPrinc.Scope.ForeColor = QBColor(15)
      Cx = FormPrinc.Scope.ScaleWidth   ' Obtient le max horizontal
      Cy = FormPrinc.Scope.ScaleHeight  ' Obtient le max vertical (bas droite)
      
    For X = 1 To 10
      If X = 5 Then
          FormPrinc.Scope.ForeColor = QBColor(0)
               Else
          FormPrinc.Scope.ForeColor = QBColor(9)
      End If
      FormPrinc.Scope.PSet (X / 10 * Cx, 0)
      FormPrinc.Scope.Line -(X / 10 * Cx, Cy)
    Next X
    
    For Y = 1 To 7
      If Y = 4 Then
          FormPrinc.Scope.ForeColor = QBColor(0)
               Else
          FormPrinc.Scope.ForeColor = QBColor(9)
      End If
      FormPrinc.Scope.PSet (0, Y / 8 * Cy)
      FormPrinc.Scope.Line -(Cx, Y / 8 * Cy)
    Next Y

End Sub

Public Sub curseurTpsTens(button As Integer, Cx As Integer, Cy As Integer)
    '--- maj curseur graphique + graph
    If (button) Then
        If (button <> 10) Then: FormPrinc.DrawGraph    '#### mj graph
        FormPrinc.Scope.DrawMode = 6 ''invert '4Not Copy Pen
        FormPrinc.Scope.DrawStyle = 1 'Dash ou dot 2
        If (FormPrinc.ChkCursTemps.Value = Checked) Then
            FormPrinc.Scope.PSet (FormPrinc.oldX, 0)        'Curseurs temps
            FormPrinc.Scope.Line -(FormPrinc.oldX, Cy)
            FormPrinc.Scope.PSet (FormPrinc.oldX2, 0)
            FormPrinc.Scope.Line -(FormPrinc.oldX2, Cy)
        End If
        If (FormPrinc.ChkCursTension.Value = Checked) Then
            FormPrinc.Scope.PSet (0, FormPrinc.oldY)        'Curseurs tension
            FormPrinc.Scope.Line -(Cx, FormPrinc.oldY)
            FormPrinc.Scope.PSet (0, FormPrinc.oldY2)
            FormPrinc.Scope.Line -(Cx, FormPrinc.oldY2)
        End If
    End If
End Sub
